## ats-lang-anairiats 0.2.0

=== Makefile ===
#########################################################################
##                                                                     ##
##                         Applied Type System                         ##
##                                                                     ##
##                              Hongwei Xi                             ##
##                                                                     ##
#########################################################################

##
## ATS/Anairiats - Unleashing the Potential of Types!
##
## Copyright (C) 2002-2008 Hongwei Xi.
##
## ATS is  free software;  you can redistribute it and/or modify it under
## the  terms of the  GNU General Public License as published by the Free
## Software Foundation; either version 2.1, or (at your option) any later
## version.
##
## ATS is distributed in the hope that it will be useful, but WITHOUT ANY
## WARRANTY; without  even  the  implied  warranty  of MERCHANTABILITY or
## FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public License
## for more details.
##
## You  should  have  received  a  copy of the GNU General Public License
## along  with  ATS;  see  the  file  COPYING.  If not, write to the Free
## Software Foundation, 51  Franklin  Street,  Fifth  Floor,  Boston,  MA
## 02110-1301, USA.
##

##
## Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
## Author: Likai Liu (liulk AT cs DOT bu DOT edu)
##

######

DESTDIR =

# Default target.

export ATSHOMERELOC

.PHONY: all
all: Makefile_main_temp
	@$(MAKE) -f Makefile_main_temp $@

######

GCC=gcc
Makefile_main_temp:: config.h
	$(GCC) -E -P -x c .makefile_header | cat - Makefile_main > Makefile_main_temp

######

# NOTE(liulk): integration with autoconf.

-include config.mk

config.h ats_env.sh test.sh: \
  config.h.in config.mk.in ats_env.sh.in test.sh.in configure
	test -x config.status && ./config.status || ./configure

Makefile: ;
configure.ac: ;
config.mk.in: ;
ats_env.sh.in: ;
test.sh.in: ;

config.mk:
	touch $@

configure: configure.ac config.h.in
	aclocal
	automake --add-missing --foreign || true
	autoconf

config.h.in: configure.ac; autoheader

# NOTE(liulk): installation to prefix

.PHONY: install
install: config.h
	# recursively install all files in the list except .svn control files.
	for d in ccomp/runtime contrib doc libats libc prelude; do \
	  cd $(abs_top_srcdir) && \
	  $(INSTALL) -d $(DESTDIR)$(ATSNEWHOME)/"$$d" && \
	  find "$$d" -name .svn -prune -o -type f \
            -exec $(INSTALL) -m 644 -D \{} $(DESTDIR)$(ATSNEWHOME)/\{} \; \
	    -print; \
	done

	# install specific files in the list as regular files.
	for f in \
	    COPYING INSTALL *.txt ccomp/lib/*.a ccomp/lib64/*.a config.h; \
	do \
	  [ -f "$$f" ] || continue; \
	  cd $(abs_top_srcdir) && \
	  $(INSTALL) -m 644 -D "$$f" $(DESTDIR)$(ATSNEWHOME)/"$$f" && \
	  echo "$$f"; \
	done

	# install specific files in the list as executables.
	for f in bin/*; do \
	  cd $(abs_top_srcdir) && \
	  $(INSTALL) -m 755 -D "$$f" $(DESTDIR)$(ATSNEWHOME)/"$$f" && \
	  echo "$$f"; \
	done

	# install multiple copies of wrapper script, for each binary.
	for f in bin/*; do \
	  b=`basename "$$f"`; \
	  cd $(abs_top_srcdir) && \
	  $(INSTALL) -m 755 -D ats_env.sh $(DESTDIR)$(bindir)/"$$b" && \
	  echo install ats_env.sh to $(bindir)/"$$b"; \
	done

.PHONY: test
test:
	sh test.sh

#
# NOTE(liulk): once most major functions of Makefile_main is
# superceded, remove the following code.
#
%: force
	@exec $(MAKE) -f Makefile_main_temp $@
force: ;

=== contrib/GL/Makefile ===
#
# Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
# Time: December, 2009
#

ATSCC="$(ATSHOME)"/bin/atscc

######

all: atsctrb_GL.o clean

######

atsctrb_GL.o: \
          gl_sats.o glu_sats.o \
          glut_sats.o glut_dats.o
	ld -r -o $@ \
          gl_sats.o glu_sats.o glut_sats.o glut_dats.o

######

gl_sats.o: SATS/gl.sats
	$(ATSCC) -o $@ -c SATS/gl.sats

glu_sats.o: SATS/glu.sats
	$(ATSCC) -o $@ -c SATS/glu.sats

glut_sats.o: SATS/glut.sats
	$(ATSCC) -o $@ -c SATS/glut.sats
glut_dats.o: DATS/glut.dats
	$(ATSCC) -o $@ -c DATS/glut.dats

######

clean::
	rm -f gl_sats.c gl_sats.o
	rm -f glu_sats.c glu_sats.o
	rm -f glut_sats.c glut_sats.o
	rm -f glut_dats.c glut_dats.o

cleanall: clean
	rm -f atsctrb_GL.o

###### end of [Makefile] ######

=== contrib/GTK/Makefile ===
#
# API for GTK in ATS
#
# Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
# Time: May, 2010
#

######

ATSCC="$(ATSHOME)"/bin/atscc
GTKCFLAGS = `pkg-config gtk+-2.0 --cflags`

######

all: atsctrb_GTK.o clean

######

atsctrb_GTK.o: GTK_dats.o
	ld -r -o $@ GTK_dats.o

######

GTK_dats.o: DATS/gtk.dats
	$(ATSCC) $(GTKCFLAGS) -o $@ -c DATS/gtk.dats

######

clean::
	rm -f *_?ats.c *_?ats.o

cleanall: clean
	rm -f atsctrb_GTK.o

###### end of [Makefile] ######

=== contrib/SDL/Makefile ===
#
# Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
# Time: January, 2010
#

ATSCC="$(ATSHOME)"/bin/atscc
SDLCFLAGS=`sdl-config --cflags`

######

all: atsctrb_SDL.o clean

######

atsctrb_SDL.o: \
  SDL_sats.o SDL_dats.o \
  SDL_image_sats.o SDL_ttf_sats.o

	ld -r -o $@ \
  SDL_sats.o SDL_dats.o \
  SDL_image_sats.o SDL_ttf_sats.o

######

SDL_sats.o: \
   SATS/SDL.sats \
   SATS/SDL_thread.sats \
   SATS/SDL_timer.sats \
   SATS/SDL_video.sats \

	$(ATSCC) $(SDLCFLAGS) -o $@ -c SATS/SDL.sats

SDL_dats.o: DATS/SDL.dats
	$(ATSCC) $(SDLCFLAGS) -o $@ -c DATS/SDL.dats

######

SDL_image_sats.o: SATS/SDL_image.sats
	$(ATSCC) $(SDLCFLAGS) -o $@ -c SATS/SDL_image.sats

######

SDL_ttf_sats.o: SATS/SDL_ttf.sats
	$(ATSCC) $(SDLCFLAGS) -o $@ -c SATS/SDL_ttf.sats

######

clean::
	rm -f SDL_sats.c SDL_sats.o
	rm -f SDL_dats.c SDL_dats.o
	rm -f SDL_image_sats.c SDL_image_sats.o
	rm -f SDL_ttf_sats.c SDL_ttf_sats.o

cleanall: clean
	rm -f atsctrb_SDL.o

###### end of [Makefile] ######

=== contrib/X11/Makefile ===
#
# API for Xlib in ATS
#
# Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
# Time: January, 2010
#

ATSCC="$(ATSHOME)"/bin/atscc

######

all: atsctrb_X11.o clean

######

atsctrb_X11.o: \
  X_sats.o \
  Xlib_sats.o Xlib_dats.o
	ld -r -o $@ \
  X_sats.o \
  Xlib_sats.o Xlib_dats.o

######

X_sats.o: SATS/X.sats
	$(ATSCC) -IX11 -o $@ -c SATS/X.sats

######

Xlib_sats.o: SATS/Xlib.sats
	$(ATSCC) -IX11 -o $@ -c SATS/Xlib.sats

Xlib_dats.o: DATS/Xlib.dats
	$(ATSCC) -IX11 -o $@ -c DATS/Xlib.dats

######

clean::
	rm -f X_sats.c X_sats.o
	rm -f Xlib_sats.c Xlib_sats.o
	rm -f Xlib_dats.c Xlib_dats.o

cleanall: clean
	rm -f atsctrb_Xlib.o

###### end of [Makefile] ######

=== contrib/cairo/Makefile ===
#
# API for cairo in ATS
#
# Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
# Time: December, 2009
#

######

ATSCC="$(ATSHOME)"/bin/atscc
XRCFLAGS=`pkg-config cairo --cflags`

######

all: atsctrb_cairo.o clean

######

atsctrb_cairo.o: cairo_dats.o
	ld -r -o $@ cairo_dats.o

######

cairo_dats.o: DATS/cairo.dats
	$(ATSCC) $(XRCFLAGS) -o $@ -c DATS/cairo.dats

######

clean::
	rm -f *_?ats.c *_?ats.o

cleanall: clean
	rm -f atsctrb_cairo.o

###### end of [Makefile] ######

=== contrib/glib/Makefile ===
#
# API for glib in ATS
#
# Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
# Time: February, 2010
#

######

GCC=gcc
ATSCC="$(ATSHOME)"/bin/atscc

GLIBINC=/usr/lib/glib-2.0/include
#GLIBINC=/usr/lib64/glib-2.0/include

INCLUDES= \
  -I $(GLIBINC) \
  -I /usr/include/glib-2.0 \

######

all:: glibconfig atsctrb_glib.o clean

######

glibconfig:: HATS/glibconfig
	$(GCC) $(INCLUDES) -E -P -o HATS/glibconfig.hats -x c HATS/glibconfig

######

atsctrb_glib.o: \
  glib_sats.o glib_dats.o
	ld -r -o $@ \
  glib_sats.o glib_dats.o

######

glib_sats.o: SATS/glib.sats
	$(ATSCC) $(INCLUDES) -o $@ -c SATS/glib.sats

glib_dats.o: DATS/glib.dats
	$(ATSCC) $(INCLUDES) -o $@ -c DATS/glib.dats

######

clean::
	rm -f glib_sats.c glib_sats.o
	rm -f glib_dats.c glib_dats.o

cleanall: clean
	rm -f atsctrb_glib.o

###### end of [Makefile] ######

=== contrib/pango/Makefile ===
#
# API for pango in ATS
#
# Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
# Time: May, 2010
#

######

ATSCC="$(ATSHOME)"/bin/atscc
PANGOCFLAGS = `pkg-config pango --cflags`

######

all: atsctrb_pango.o clean

######

atsctrb_pango.o: pango_dats.o
	ld -r -o $@ pango_dats.o

######

pango_dats.o: DATS/pango.dats
	$(ATSCC) $(PANGOCFLAGS) -o $@ -c DATS/pango.dats

######

clean::
	rm -f *_?ats.c *_?ats.o

cleanall: clean
	rm -f atsctrb_pango.o

###### end of [Makefile] ######

=== utils/atslex/Makefile ===
#########################################################################
#                                                                       #
#                         Applied Type System                           #
#                                                                       #
#                              Hongwei Xi                               #
#                                                                       #
#########################################################################

#
#  ATS - Unleashing the Power of Types!
#
#  Copyright (C) 2002-2007 Hongwei Xi.
#
#  ATS is free software;  you can  redistribute it and/or modify it under
#  the terms of the GNU LESSER GENERAL PUBLIC LICENSE as published by the
#  Free Software Foundation; either version 2.1, or (at your option)  any
#  later version.
# 
#  ATS is distributed in the hope that it will be useful, but WITHOUT ANY
#  WARRANTY; without  even  the  implied  warranty  of MERCHANTABILITY or
#  FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public License
#  for more details.
# 
#  You  should  have  received  a  copy of the GNU General Public License
#  along  with  ATS;  see  the  file  COPYING.  If not, write to the Free
#  Software Foundation, 51  Franklin  Street,  Fifth  Floor,  Boston,  MA
#  02110-1301, USA.
#

#
# Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
#

######

ATSCC="$(ATSHOME)"/bin/atscc
#ATSCCFLAGS=-D_ATS_gc
#ATSCCFLAGS=-D_ATS_gcats
#ATSCCFLAGS=-D_ATS_GCATS
ATSCCFLAGS=
ATSRUNTIME="$(ATSHOME)"/ccomp/runtime

#CCFLAGS=-O3 -g
CCFLAGS=-g
INCLUDES=-I"$(ATSHOME)" -I"$(ATSRUNTIME)" -I

######

atslex: \
  atslex.dats top_sats.o lexgen_dats.o \
  charset_dats.o intset_dats.o states_dats.o \
  parser_dats.o position_dats.o token_dats.o
	$(ATSCC) $(ATSCCFLAGS) -o atslex \
  atslex.dats top_sats.o lexgen_dats.o \
  charset_dats.o intset_dats.o states_dats.o \
  parser_dats.o position_dats.o token_dats.o

######

charset_dats.o: charset.dats
	$(ATSCC) $(CCFLAGS) -c charset.dats
intset_dats.o: intset.dats
	$(ATSCC) $(CCFLAGS) -c intset.dats
lexgen_dats.o: lexgen.dats
	$(ATSCC) $(CCFLAGS) -c lexgen.dats
parser_dats.o: parser.dats
	$(ATSCC) $(CCFLAGS) -c parser.dats
position_dats.o: position.dats
	$(ATSCC) $(CCFLAGS) -c position.dats
states_dats.o: states.dats
	$(ATSCC) $(CCFLAGS) -c states.dats
token_dats.o: token.dats
	$(ATSCC) $(CCFLAGS) -c token.dats
top_sats.o: top.sats
	$(ATSCC) $(CCFLAGS) -c top.sats

######

clean::
	rm -f *_sats.c *_dats.c *.o *~

cleanall: clean; rm -f atslex

###### end of [Makefile] ######

=== utils/scripts/Makefile ===
#########################################################################
#                                                                       #
#                         Applied Type System                           #
#                                                                       #
#                              Hongwei Xi                               #
#                                                                       #
#########################################################################

#
#  ATS - Unleashing the Power of Types!
#
#  Copyright (C) 2002-2007 Hongwei Xi.
#
#  ATS is  free software;  you can redistribute it and/or modify it under
#  the  terms of the  GNU General Public License as published by the Free
#  Software Foundation; either version 2.1, or (at your option) any later
#  version.
# 
#  ATS is distributed in the hope that it will be useful, but WITHOUT ANY
#  WARRANTY; without  even  the  implied  warranty  of MERCHANTABILITY or
#  FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public License
#  for more details.
# 
#  You  should  have  received  a  copy of the GNU General Public License
#  along  with  ATS;  see  the  file  COPYING.  If not, write to the Free
#  Software Foundation, 51  Franklin  Street,  Fifth  Floor,  Boston,  MA
#  02110-1301, USA.
#

#
# Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
#

######

ATSOPT="$(ATSHOME)"/bin/atsopt
ATSRUNTIME="$(ATSHOME)"/ccomp/runtime
ATSLIBC="$(ATSHOME)"/libc
ATSCC="$(ATSHOME)"/bin/atscc

CC=gcc
INCLUDES=-I"$(ATSHOME)" -I$(ATSRUNTIME)
CCFLAGS=-O2 -g

######

all: atscc atslib
	echo "[atscc] and [atslib] have been generated."

atscc:  atscc_main_dats.c \
          top_sats.o basics_dats.o pkgconfig.o atscc_dats.o \
          errno_sats.o fcntl_sats.o stdio_sats.o stdlib_sats.o string_sats.o unistd_sats.o \
          sys_types_sats.o sys_wait_sats.o
	$(CC) $(INCLUDES) $(CCFLAGS) -o atscc atscc_main_dats.c $(ATSRUNTIME)/ats_prelude.c \
          top_sats.o basics_dats.o pkgconfig.o atscc_dats.o \
          errno_sats.o fcntl_sats.o stdio_sats.o stdlib_sats.o string_sats.o unistd_sats.o \
          sys_types_sats.o sys_wait_sats.o

atslib: atslib_main_dats.c \
          top_sats.o basics_dats.o atscc_dats.o atslib_dats.o \
          fcntl_sats.o stdio_sats.o stdlib_sats.o unistd_sats.o \
          sys_types_sats.o sys_wait_sats.o
	$(CC) $(INCLUDES) $(CCFLAGS) -o atslib atslib_main_dats.c $(ATSRUNTIME)/ats_prelude.c \
          top_sats.o basics_dats.o atscc_dats.o atslib_dats.o \
          fcntl_sats.o stdio_sats.o stdlib_sats.o unistd_sats.o \
          sys_types_sats.o sys_wait_sats.o

atspack: atspack.dats
	$(ATSCC) -o atspack $(CCFLAGS) atspack.dats

deltabs: deltabs.dats
	$(ATSCC) -o deltabs $(CCFLAGS) deltabs.dats -D_ATS_gcats

######

top_sats.c: top.sats
	$(ATSOPT) --output $@ --static top.sats
top_sats.o: top_sats.c
	$(CC) $(INCLUDES) $(CCFLAGS) -o $@ -c top_sats.c

basics_dats.c: top.sats basics.dats
	$(ATSOPT) --output $@ --dynamic basics.dats
basics_dats.o: basics_dats.c
	$(CC) $(INCLUDES) $(CCFLAGS) -o $@ -c basics_dats.c

######

pkgconfig_dats.c: pkgconfig.dats
	$(ATSOPT) --output $@ --dynamic pkgconfig.dats

pkgconfig.o: pkgconfig_dats.c
	$(CC) $(INCLUDES) $(CCFLAGS) -o $@ -c pkgconfig_dats.c

######

atscc_dats.c: top.sats atscc.dats
	$(ATSOPT) --output $@ --dynamic atscc.dats
atscc_dats.o: atscc_dats.c
	$(CC) $(INCLUDES) $(CCFLAGS) -o $@ -c atscc_dats.c

atscc_main_dats.c: atscc_main.dats
	$(ATSOPT) --output $@ --dynamic atscc_main.dats

######

atslib_dats.c: top.sats atslib.dats
	$(ATSOPT) --output $@ --dynamic atslib.dats
atslib_dats.o: atslib_dats.c
	$(CC) $(INCLUDES) $(CCFLAGS) -o $@ -c atslib_dats.c

atslib_main_dats.c: atslib_main.dats
	$(ATSOPT) --output $@ --dynamic atslib_main.dats

######

errno_sats.c:
	$(ATSOPT) --output $@ --static $(ATSLIBC)/SATS/errno.sats
errno_sats.o: errno_sats.c
	$(CC) $(INCLUDES) $(CCFLAGS) -o $@ -c errno_sats.c

fcntl_sats.c:
	$(ATSOPT) --output $@ --static $(ATSLIBC)/SATS/fcntl.sats
fcntl_sats.o: fcntl_sats.c
	$(CC) $(INCLUDES) $(CCFLAGS) -o $@ -c fcntl_sats.c

stdio_sats.c:
	$(ATSOPT) --output $@ --static $(ATSLIBC)/SATS/stdio.sats
stdio_sats.o: stdio_sats.c
	$(CC) $(INCLUDES) $(CCFLAGS) -o $@ -c stdio_sats.c

stdlib_sats.c:
	$(ATSOPT) --output $@ --static $(ATSLIBC)/SATS/stdlib.sats
stdlib_sats.o: stdlib_sats.c
	$(CC) $(INCLUDES) $(CCFLAGS) -o $@ -c stdlib_sats.c

string_sats.c:
	$(ATSOPT) --output $@ --static $(ATSLIBC)/SATS/string.sats
string_sats.o: string_sats.c
	$(CC) $(INCLUDES) $(CCFLAGS) -o $@ -c string_sats.c

unistd_sats.c:
	$(ATSOPT) --output $@ --static $(ATSLIBC)/SATS/unistd.sats
unistd_sats.o: unistd_sats.c
	$(CC) $(INCLUDES) $(CCFLAGS) -o $@ -c unistd_sats.c

sys_types_sats.c:
	$(ATSOPT) --output $@ --static $(ATSLIBC)/sys/SATS/types.sats
sys_types_sats.o: sys_types_sats.c
	$(CC) $(INCLUDES) $(CCFLAGS) -o $@ -c sys_types_sats.c

sys_wait_sats.c:
	$(ATSOPT) --output $@ --static $(ATSLIBC)/sys/SATS/wait.sats
sys_wait_sats.o: sys_wait_sats.c
	$(CC) $(INCLUDES) $(CCFLAGS) -o $@ -c sys_wait_sats.c

######

clean::
	rm -f *_sats.c *_dats.c *.o *~

cleanall:: clean
	rm -f atscc atslib atspack

######

=== doc/EXAMPLE/GTK/Makefile ===
#
#
# Some Examples in ATS involving GTK+ programming
#
#

######

ATSCC=$(or $(ATSHOME), "/usr")/bin/atscc
ATSOPT=$(or $(ATSHOME), "/usr")/bin/atsopt
GTKFLAGS=`pkg-config gtk+-2.0 --cflags --libs`

######

.PHONY: all
all: checkall

######

checkall:: compall cleanall

compall:: \
  GameOf24 \
  gtkcairoclock \

######

#
# Please do the following
#   cd $ATSHOME/contrib/GTK; make atsctrb_GTK.o
# if "atsctrb_GTK.o" is not available
#
LIBATSGTK=$(ATSHOME)/contrib/GTK/atsctrb_GTK.o
GameOf24: GameOf24.dats
	$(ATSCC) -D_ATS_GCATS -o $@ $(GTKFLAGS) GameOf24.dats $(LIBATSGTK)

######

gtkcairoclock: gtkcairoclock.dats
	$(ATSCC) -o $@ gtkcairoclock.dats $(GTKFLAGS)

######

clean::
	rm -f *_dats.c *_sats.c *~

cleanall:: clean
	rm -f GameOf24
	rm -f gtkcairoclock

###### end of [Makefile] ######

=== doc/EXAMPLE/INTRO/Makefile ===
#
#
# Some introductory examples 
#
#

######

ATSCC=$(or $(ATSHOME), "/usr")/bin/atscc
ATSOPT=$(or $(ATSHOME), "/usr")/bin/atsopt

######

.PHONY: all
all: checkall

######

checkall: compall cleanall

compall: \
  HelloWorld f91 fact1 fact2 fact3 fibs revarr revstr

HelloWorld: HelloWorld.dats
	rm -f HelloWorld
	$(ATSCC) -o HelloWorld HelloWorld.dats && ./HelloWorld

f91: f91.dats
	rm -f f91
	$(ATSCC) -o f91 f91.dats && ./f91 0

fact1: fact1.dats
	$(ATSCC) -o fact1 fact1.dats && ./fact1 10

fact2: fact2.dats
	$(ATSCC) -o fact2 fact2.dats && ./fact2 10

fact3: fact3.dats
	$(ATSCC) -o fact3 fact3.dats -lats -lgmp && ./fact3 100

fact4: fact4.dats
	$(ATSCC) -o fact4 fact4.dats -lats -lgmp && ./fact4 10

fact_in_c: fact_in_c.dats
	$(ATSCC) -o fact_in_c fact_in_c.dats && ./fact_in_c 10

fibs: fibs.dats
	$(ATSCC) -o fibs fibs.dats -lats -lgmp && ./fibs 40

revarr: revarr.dats
	$(ATSCC) -o revarr revarr.dats && ./revarr

revstr: revstr.dats
	$(ATSCC) -o revstr revstr.dats && ./revstr "abcdefghijklmnopqrstuvwxyz"

######

html::
	$(ATSOPT) --posmark_html -d HelloWorld.dats > HelloWorld_dats.html
	$(ATSOPT) --posmark_html -d f91.dats > f91_dats.html
	$(ATSOPT) --posmark_html -d fact1.dats > fact1_dats.html
	$(ATSOPT) --posmark_html -d fact2.dats > fact2_dats.html
	$(ATSOPT) --posmark_html -d fact3.dats > fact3_dats.html
	$(ATSOPT) --posmark_html -d fact4.dats > fact4_dats.html
	$(ATSOPT) --posmark_html -d fact_in_c.dats > fact_in_c_dats.html
	$(ATSOPT) --posmark_html -d fibs.dats > fibs_dats.html
	$(ATSOPT) --posmark_html -d revarr.dats > revarr_dats.html
	$(ATSOPT) --posmark_html -d revstr.dats > revstr_dats.html

######

clean::
	rm -f INTRO/*
	rm -f *_dats.c *_sats.c *_dats.html *_sats.html *~

cleanall:: clean
	if [ -f HelloWorld ] ; then rm HelloWorld ; fi
	if [ -f f91 ] ; then rm f91 ; fi
	if [ -f fact1 ] ; then rm fact1 ; fi
	if [ -f fact2 ] ; then rm fact2 ; fi
	if [ -f fact3 ] ; then rm fact3 ; fi
	if [ -f fact4 ] ; then rm fact4 ; fi
	if [ -f fact_in_c ] ; then rm fact_in_c ; fi
	if [ -f fibs ] ; then rm fibs ; fi
	if [ -f revarr ] ; then rm revarr ; fi
	if [ -f revstr ] ; then rm revstr ; fi

###### end of [Makefile] ######

=== debian/changelog ===
ats-lang-anairiats (0.2.0-1) unstable; urgency=low

  * New upstream release
  * Modifying example Makefiles to build, test, and not clean.
  * Working around build system bug to do with Makefile_main_temp.

 -- Matthew Danish <mrd@debian.org>  Sun, 13 Jun 2010 17:46:45 -0400

ats-lang-anairiats (0.1.8-1) unstable; urgency=low

  * Initial release (Closes: #571031)

 -- Matthew Danish <mrd@debian.org>  Fri, 5 Mar 2010 20:35:01 -0500

=== debian/control ===
Source: ats-lang-anairiats
Section: devel
Priority: optional
Maintainer: Matthew Danish <mrd@debian.org>
Build-Depends: debhelper (>= 7), libgmp3-dev, libpcre3-dev, libsdl1.2-dev, libgtk2.0-dev, libcairo2-dev
Standards-Version: 3.8.4
Homepage: http://www.ats-lang.org

Package: ats-lang-anairiats
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libgmp3-dev, libpcre3-dev, libsdl1.2-dev, libgtk2.0-dev, libcairo2-dev
Suggests: ats-lang-anairiats-examples, ats-lang-anairiats-doc
Description: The ATS language compiler Anairiats
 ATS is a programming language with a highly expressive type system
 rooted in the framework Applied Type System. In particular, both
 dependent types and linear types are available in ATS. The current
 implementation of ATS (ATS/Anairiats) is written in ATS itself. It
 can be as efficient as C/C++ and supports a variety of programming
 paradigms.
 .
 In addition, ATS contains a component ATS/LF that supports a form of
 (interactive) theorem proving, where proofs are constructed as total
 functions. With this component, ATS advocates a programming style
 that combines programming with theorem proving. Furthermore, this
 component may be used as a logical framework to encode various
 deduction systems and their (meta-)properties.
 .
 This package contains the compiler atsopt, the frontend atscc, and 
 the lexer atslex.

Package: ats-lang-anairiats-examples
Architecture: all
Depends: ${misc:Depends}
Recommends: ats-lang-anairiats
Description: Examples for the ATS compiler Anairiats
 ATS is a programming language with a highly expressive type system
 rooted in the framework Applied Type System. In particular, both
 dependent types and linear types are available in ATS. The current
 implementation of ATS (ATS/Anairiats) is written in ATS itself. It
 can be as efficient as C/C++ and supports a variety of programming
 paradigms.
 .
 In addition, ATS contains a component ATS/LF that supports a form of
 (interactive) theorem proving, where proofs are constructed as total
 functions. With this component, ATS advocates a programming style
 that combines programming with theorem proving. Furthermore, this
 component may be used as a logical framework to encode various
 deduction systems and their (meta-)properties.
 .
 This package contains some examples of the language.

Package: ats-lang-anairiats-doc
Architecture: all
Depends: ${misc:Depends}
Recommends: ats-lang-anairiats
Section: doc
Description: Documentation for the ATS compiler Anairiats
 ATS is a programming language with a highly expressive type system
 rooted in the framework Applied Type System. In particular, both
 dependent types and linear types are available in ATS. The current
 implementation of ATS (ATS/Anairiats) is written in ATS itself. It
 can be as efficient as C/C++ and supports a variety of programming
 paradigms.
 .
 In addition, ATS contains a component ATS/LF that supports a form of
 (interactive) theorem proving, where proofs are constructed as total
 functions. With this component, ATS advocates a programming style
 that combines programming with theorem proving. Furthermore, this
 component may be used as a logical framework to encode various
 deduction systems and their (meta-)properties.
 .
 This package contains some documentation for the language.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

%:
	dh  $@

clean:
	dh $@ --before dh_auto_clean clean
	dh $@ --after dh_auto_clean clean
	make cleanall
	rm -f stamp-h1 config.log config.status .ATSHOME .ATSHOMERELOC
	rm -f ats_env.sh test.sh config.mk
	rm -f ccomp/lib/output/* ccomp/lib64/output/*
	rm -f ccomp/lib/*.a ccomp/lib64/*.a

## ats-lang-anairiats 0.2.3

=== Makefile ===
--- 
+++ 
@@ -27,59 +27,57 @@
 ## 02110-1301, USA.
 ##
 
+######
+
 ##
 ## Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
 ## Author: Likai Liu (liulk AT cs DOT bu DOT edu)
-##
-
-######
-
-DESTDIR =
-
-# Default target.
-
-export ATSHOMERELOC
-
-.PHONY: all
-all: Makefile_main_temp
-	@$(MAKE) -f Makefile_main_temp $@
-
-######
-
-GCC=gcc
-Makefile_main_temp:: config.h
-	$(GCC) -E -P -x c .makefile_header | cat - Makefile_main > Makefile_main_temp
-
-######
-
-# NOTE(liulk): integration with autoconf.
-
--include config.mk
-
-config.h ats_env.sh test.sh: \
-  config.h.in config.mk.in ats_env.sh.in test.sh.in configure
-	test -x config.status && ./config.status || ./configure
-
-Makefile: ;
-configure.ac: ;
-config.mk.in: ;
-ats_env.sh.in: ;
-test.sh.in: ;
-
-config.mk:
+## Author: Yuri D'Elia (wavexx AT thregr DOT org)
+##
+
+.SUFFIXES:
+all:: Makefile
+
+######
+
+# integration with autoconf.
+
+SRC_CONFIG_FILES := config.mk.in config.h.in
+BUILT_CONFIG_FILES := $(SRC_CONFIG_FILES:%.in=%)
+
+Makefile: config.mk
+
+config.status: configure
+	./configure
 	touch $@
 
-configure: configure.ac config.h.in
+$(BUILT_CONFIG_FILES): %: config.status $(filter-out %,$(SRC_CONFIG_FILES))
+	./config.status
+	touch $(BUILT_CONFIG_FILES)
+
+config.h.in: configure.ac
+	autoheader $<
+	touch $@
+
+configure: configure.ac $(SRC_CONFIG_FILES)
 	aclocal
 	automake --add-missing --foreign || true
 	autoconf
-
-config.h.in: configure.ac; autoheader
-
-# NOTE(liulk): installation to prefix
-
-.PHONY: install
-install: config.h
+	touch $(BUILT_CONFIG_FILES)
+
+-include config.mk
+
+######
+
+DESTDIR :=
+
+export ATSHOME
+export ATSHOMERELOC
+export ATSHOMEQ
+
+######
+
+install:: config.h
 	# recursively install all files in the list except .svn control files.
 	for d in ccomp/runtime contrib doc libats libc prelude; do \
 	  cd $(abs_top_srcdir) && \
@@ -114,14 +112,140 @@
 	  echo install ats_env.sh to $(bindir)/"$$b"; \
 	done
 
-.PHONY: test
-test:
-	sh test.sh
-
-#
-# NOTE(liulk): once most major functions of Makefile_main is
-# superceded, remove the following code.
-#
-%: force
-	@exec $(MAKE) -f Makefile_main_temp $@
-force: ;
+######
+
+all:: \
+  atsopt1 \
+  bin/atscc \
+  bin/atslib \
+  libfiles libfiles_mt \
+  bin/atspack \
+  bin/atslex \
+  ccomp/runtime/GCATS/gc.o \
+  ccomp/runtime/GCATS/gc_mt.o \
+  atsopt1_gc \
+  contrib
+	@echo "ATS/Anairiats has been built up successfully!"
+	@echo "The value of ATSHOME for this build is \"$(ATSHOME)\"."
+	@echo "The value of ATSHOMERELOC for this build is \"$(ATSHOMERELOC)\"."
+
+###### w/o GC ######
+
+atsopt1::
+	$(MAKE) -C bootstrap1 -f ../Makefile_bootstrap BOOTSTRAP1=1 atsopt
+	cp bootstrap1/atsopt $(ATSHOMEQ)/bin/atsopt
+
+###### with GC ######
+
+atsopt1_gc::
+	$(MAKE) -C bootstrap1 -f ../Makefile_bootstrap BOOTSTRAP1=1 atsopt_gc
+	cp bootstrap1/atsopt_gc $(ATSHOMEQ)/bin/atsopt
+
+###### contrib libraries ######
+
+contrib::
+ifeq ($(HAVE_LIBGLIB20),1)
+	cd contrib/glib; make atsctrb_glib.o; make clean
+endif
+ifeq ($(HAVE_LIBGTK20),1)
+	cd contrib/cairo; make atsctrb_cairo.o; make clean
+	cd contrib/pango; make atsctrb_pango.o; make clean
+	cd contrib/GTK; make atsctrb_GTK.o; make clean
+endif
+ifeq ($(HAVE_LIBSDL10),1)
+	cd contrib/SDL; make atsctrb_SDL.o; make clean
+endif
+
+###### some toplevel commands ######
+
+bin/atscc bin/atslib:
+	cd utils/scripts; $(MAKE) atscc; cp atscc $(ATSHOMEQ)/bin
+	cd utils/scripts; $(MAKE) atslib; cp atslib $(ATSHOMEQ)/bin
+	cd utils/scripts; $(MAKE) clean
+
+bin/atspack:
+	cd utils/scripts; $(MAKE) atspack; cp atspack $(ATSHOMEQ)/bin
+
+###### library ######
+
+ATS_PROOFCHECK=
+#
+# ATS_PROOFCHECK=-D_ATS_PROOFCHECK # it should be turned on from time to time
+#
+# [CC -E] for preprocessing
+#
+
+ATSLIB=$(ATSHOMEQ)/bin/atslib
+
+.libfiles_local: .libfiles ; $(CC) -E -P -x c -o $@ $<
+libfiles: .libfiles_local
+	$(ATSLIB) $(ATS_PROOFCHECK) -D_XOPEN_SOURCE -O2 --libats
+	$(ATSLIB) $(ATS_PROOFCHECK) -O2 --libats_lex
+	$(ATSLIB) $(ATS_PROOFCHECK) -O2 --libats_smlbas
+
+lib32files: .libfiles_local
+	$(ATSLIB) $(ATS_PROOFCHECK) -m32 -D_XOPEN_SOURCE -O2 --libats
+	$(ATSLIB) $(ATS_PROOFCHECK) -m32 -O2 --libats_lex
+	$(ATSLIB) $(ATS_PROOFCHECK) -m32 -O2 --libats_smlbas
+
+lib64files: .libfiles_local
+	$(ATSLIB) $(ATS_PROOFCHECK) -m64 -D_XOPEN_SOURCE -O2 --libats
+	$(ATSLIB) $(ATS_PROOFCHECK) -m64 -O2 --libats_lex
+	$(ATSLIB) $(ATS_PROOFCHECK) -m64 -O2 --libats_smlbas
+
+.libfiles_mt_local: .libfiles_mt ; $(CC) -E -P -x c -o $@ $<
+libfiles_mt: .libfiles_mt_local
+	$(ATSLIB) $(ATS_PROOFCHECK) -D_ATS_MULTITHREAD -O2 --libats_mt
+
+###### a lexer for ATS ######
+
+bin/atslex:
+	cd utils/atslex; $(MAKE) atslex; cp atslex $(ATSHOMEQ)/bin
+	cd utils/atslex; $(MAKE) clean
+
+###### GC runtime ######
+
+ccomp/runtime/GCATS/gc.o:
+	cd ccomp/runtime/GCATS; $(MAKE) gc.o; $(MAKE) clean
+
+ccomp/runtime/GCATS/gc_mt.o:
+	cd ccomp/runtime/GCATS; $(MAKE) gc_mt.o; $(MAKE) clean
+
+######
+
+clean::
+	rm -f bootstrap1/*.o
+	cd utils/scripts; $(MAKE) clean
+	cd utils/atslex; $(MAKE) clean
+	cd ccomp/runtime/GCATS; $(MAKE) clean
+
+cleanall:: clean
+	rm -f $(BUILT_CONFIG_FILES)
+	rm -f .libfiles_local
+	rm -f .libfiles_mt_local
+	rm -f bin/atsopt bin/atscc bin/atslib bin/atslex bin/atspack
+	rm -f ccomp/lib/libats.a
+	rm -f ccomp/lib/libats_mt.a
+	rm -f ccomp/lib/libats_lex.a
+	rm -f ccomp/lib/libats_smlbas.a
+	rm -f ccomp/lib/output/*
+	rm -f ccomp/lib64/libats.a
+	rm -f ccomp/lib64/libats_mt.a
+	rm -f ccomp/lib64/libats_lex.a
+	rm -f ccomp/lib64/libats_smlbas.a
+	rm -f ccomp/lib64/output/*
+	cd ccomp/runtime/GCATS; $(MAKE) cleanall
+	rm -f contrib/glib/atsctrb_glib.o
+	rm -f contrib/cairo/atsctrb_cairo.o
+	rm -f contrib/pango/atsctrb_pango.o
+	rm -f contrib/X11/atsctrb_X11.o
+	rm -f contrib/GTK/atsctrb_GTK.o
+	rm -f contrib/GL/atsctrb_GL.o
+	rm -f contrib/SDL/atsctrb_SDL.o
+	find . -name .svn -prune -o -name \*~ -exec rm \{} \;
+
+######
+#
+# end of [Makefile_dist]
+#
+######

=== contrib/GL/Makefile ===
--- 
+++ 
@@ -3,7 +3,10 @@
 # Time: December, 2009
 #
 
-ATSCC="$(ATSHOME)"/bin/atscc
+######
+
+ATSHOMEQ="$(ATSHOME)"
+ATSCC=$(ATSHOMEQ)/bin/atscc
 
 ######

=== contrib/GTK/Makefile ===
--- 
+++ 
@@ -7,7 +7,8 @@
 
 ######
 
-ATSCC="$(ATSHOME)"/bin/atscc
+ATSHOMEQ="$(ATSHOME)"
+ATSCC=$(ATSHOMEQ)/bin/atscc -Wall
 GTKCFLAGS = `pkg-config gtk+-2.0 --cflags`
 
 ######

=== contrib/SDL/Makefile ===
--- 
+++ 
@@ -3,7 +3,10 @@
 # Time: January, 2010
 #
 
-ATSCC="$(ATSHOME)"/bin/atscc
+######
+
+ATSHOMEQ="$(ATSHOME)"
+ATSCC=$(ATSHOMEQ)/bin/atscc -Wall
 SDLCFLAGS=`sdl-config --cflags`
 
 ######
@@ -45,13 +48,17 @@
 
 ######
 
+RMF = rm -f
+
+######
+
 clean::
-	rm -f SDL_sats.c SDL_sats.o
-	rm -f SDL_dats.c SDL_dats.o
-	rm -f SDL_image_sats.c SDL_image_sats.o
-	rm -f SDL_ttf_sats.c SDL_ttf_sats.o
+	$(RMF) SDL_sats.c SDL_sats.o
+	$(RMF) SDL_dats.c SDL_dats.o
+	$(RMF) SDL_image_sats.c SDL_image_sats.o
+	$(RMF) SDL_ttf_sats.c SDL_ttf_sats.o
 
 cleanall: clean
-	rm -f atsctrb_SDL.o
+	$(RMF) atsctrb_SDL.o
 
 ###### end of [Makefile] ######

=== contrib/X11/Makefile ===
--- 
+++ 
@@ -5,7 +5,10 @@
 # Time: January, 2010
 #
 
-ATSCC="$(ATSHOME)"/bin/atscc
+######
+
+ATSHOMEQ="$(ATSHOME)"
+ATSCC=$(ATSHOMEQ)/bin/atscc -Wall
 
 ######

=== contrib/cairo/Makefile ===
--- 
+++ 
@@ -7,7 +7,8 @@
 
 ######
 
-ATSCC="$(ATSHOME)"/bin/atscc
+ATSHOMEQ="$(ATSHOME)"
+ATSCC=$(ATSHOMEQ)/bin/atscc -Wall
 XRCFLAGS=`pkg-config cairo --cflags`
 
 ######
@@ -16,13 +17,17 @@
 
 ######
 
-atsctrb_cairo.o: cairo_dats.o
-	ld -r -o $@ cairo_dats.o
+atsctrb_cairo.o: \
+  cairo_dats.o cairo_extra_dats.o
+	ld -r -o $@ $?
 
 ######
 
 cairo_dats.o: DATS/cairo.dats
 	$(ATSCC) $(XRCFLAGS) -o $@ -c DATS/cairo.dats
+
+cairo_extra_dats.o: DATS/cairo_extra.dats
+	$(ATSCC) $(XRCFLAGS) -o $@ -c DATS/cairo_extra.dats
 
 ######

=== contrib/cblas/Makefile ===
#
# API for cblas in ATS
#
# Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
# Author: Shivkumar Chandrasekaran (shiv AT ece DOT ucsb DOT edu)
# Time: July, 2010
#

######

ATSHOMEQ="$(ATSHOME)"
ATSCC=$(ATSHOMEQ)/bin/atscc -Wall

LD=ld
LIBFLAGS=-L/usr/lib/atlas

######

all: atsctrb_cblas.o clean

######

atsctrb_cblas.o: \
  cblas_dats.o cblas_extra_dats.o
	$(LD) -r -o $@ $^

######

cblas_dats.o: DATS/cblas.dats
	$(ATSCC) $(LIBFLAGS) -o $@ -c DATS/cblas.dats

cblas_extra_dats.o: DATS/cblas_extra.dats
	$(ATSCC) $(LIBFLAGS) -o $@ -c DATS/cblas_extra.dats

######

clean::
	rm -f *_?ats.c *_?ats.o

cleanall: clean
	rm -f atsctrb_cblas.o

###### end of [Makefile] ######

=== contrib/clapack/Makefile ===
#
# API for clapack in ATS
#
# Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
# Author: Shivkumar Chandrasekaran (shiv AT ece DOT ucsb DOT edu)
# Time: July, 2010
#

######

ATSHOMEQ="$(ATSHOME)"
ATSCC=$(ATSHOMEQ)/bin/atscc -Wall
LIBFLAGS=-L/usr/lib/atlas

######

all: atsctrb_clapack.o clean

######

atsctrb_clapack.o: clapack_dats.o
	ld -r -o $@ clapack_dats.o

######

clapack_dats.o: DATS/clapack.dats
	$(ATSCC) $(LIBFLAGS) -o $@ -c DATS/clapack.dats

######

clean::
	rm -f *_?ats.c *_?ats.o

cleanall: clean
	rm -f atsctrb_clapack.o

###### end of [Makefile] ######

=== contrib/glib/Makefile ===
--- 
+++ 
@@ -7,15 +7,18 @@
 
 ######
 
+ATSHOMEQ="$(ATSHOME)"
+ATSCC=$(ATSHOMEQ)/bin/atscc -Wall
+
+######
+
 GCC=gcc
-ATSCC="$(ATSHOME)"/bin/atscc
 
-GLIBINC=/usr/lib/glib-2.0/include
-#GLIBINC=/usr/lib64/glib-2.0/include
+######
 
-INCLUDES= \
-  -I $(GLIBINC) \
-  -I /usr/include/glib-2.0 \
+GLIBINC := -I"/usr/lib/glib-2.0/include"
+GLIBINC += -I"/usr/lib64/glib-2.0/include"
+INCLUDES= $(GLIBINC) -I"/usr/include/glib-2.0"
 
 ######

=== contrib/pango/Makefile ===
--- 
+++ 
@@ -7,8 +7,9 @@
 
 ######
 
-ATSCC="$(ATSHOME)"/bin/atscc
-PANGOCFLAGS = `pkg-config pango --cflags`
+ATSHOMEQ="$(ATSHOME)"
+ATSCC=$(ATSHOMEQ)/bin/atscc
+PANGOCFLAGS=`pkg-config pango --cflags`
 
 ######

=== utils/scripts/Makefile ===
--- 
+++ 
@@ -33,13 +33,14 @@
 
 ######
 
-ATSOPT="$(ATSHOME)"/bin/atsopt
-ATSRUNTIME="$(ATSHOME)"/ccomp/runtime
-ATSLIBC="$(ATSHOME)"/libc
-ATSCC="$(ATSHOME)"/bin/atscc
+ATSHOMEQ="$(ATSHOME)"
+ATSOPT=$(ATSHOMEQ)/bin/atsopt
+ATSRUNTIME=$(ATSHOMEQ)/ccomp/runtime
+ATSLIBC=$(ATSHOMEQ)/libc
+ATSCC=$(ATSHOMEQ)/bin/atscc
 
 CC=gcc
-INCLUDES=-I"$(ATSHOME)" -I$(ATSRUNTIME)
+INCLUDES=-I$(ATSHOMEQ) -I$(ATSRUNTIME)
 CCFLAGS=-O2 -g
 
 ######

=== ccomp/runtime/GCATS/Makefile ===
#########################################################################
##                                                                     ##
##                         Applied Type System                         ##
##                                                                     ##
##                              Hongwei Xi                             ##
##                                                                     ##
#########################################################################

##
## ATS/Anairiats - Unleashing the Power of Types!
##
## Copyright (C) 2002-2008 Hongwei Xi, Boston University
##
## All rights reserved
##
## ATS is  free software;  you can redistribute it and/or modify it under
## the  terms of the  GNU General Public License as published by the Free
## Software Foundation; either version 2.1, or (at your option) any later
## version.
## 
## ATS is distributed in the hope that it will be useful, but WITHOUT ANY
## WARRANTY; without  even  the  implied  warranty  of MERCHANTABILITY or
## FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public License
## for more details.
## 
## You  should  have  received  a  copy of the GNU General Public License
## along  with  ATS;  see the  file COPYING.  If not, please write to the
## Free Software Foundation,  51 Franklin Street, Fifth Floor, Boston, MA
## 02110-1301, USA.
##

## ###### ###### ##

## Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
## Time: June 2008

## ###### ###### ##

GCC=gcc
ATSCC="${ATSHOME}"/bin/atscc

#ATSCCFLAG=-g
#ATSCCFLAG=-DGCATS_DEBUG
#ATSCCFLAG=-g
ATSCCFLAG=-O3 -g
#ATSCCFLAG=-O3
#CCFLAG=
CCFLAG=-O3

SOURCES := \
  gcats1_misc.dats \
  gcats1_freeitmlst.dats \
  gcats1_chunk.dats \
  gcats1_globalentry.dats \
  gcats1_marking.dats \
  gcats1_collecting.dats \
  gcats1_autops.dats \
  gcats1_manops.dats \
  gcats1_top.dats \

TARGETS := $(patsubst %.dats, %_dats.c, $(SOURCES))
TARGETS_mt := $(TARGETS) gcats1_multithread_dats.c
OBJECTS := $(patsubst %.dats, %_dats.o, $(SOURCES))
OBJECTS_mt := $(OBJECTS) gc_multithread_dats.o

######

#
# this generates a slower version:
#
# gc.o: gcats1_sats.o $(OBJECTS)
#	ld -r -o gc.o gcats1_sats.o $(OBJECTS)
#

gc.o: gc0_hats gcats1_sats.o gcats1_all_cats.o
	ld -r -o $@ gcats1_sats.o gcats1_all_cats.o

gc_mt.o: gc1_hats gcats1_sats.o gcats1_mt_all_cats.o
	ld -r -o $@ gcats1_sats.o gcats1_mt_all_cats.o

######

#
# mainly for the purpose of debugging
#
gcats1_main: gc0_hats gc.cats gcats1_sats.c gcats1_main.dats $(OBJECTS)
	$(ATSCC) $(CCFLAG) -o gcats1_main gcats1_main.dats gcats1_sats.c $(OBJECTS)

gcats1_main_mt: gc1_hats gc.cats gcats1_sats.c gcats1_main.dats $(OBJECTS_mt)
	$(ATSCC) $(CCFLAG) -pthread -o gcats1_main_mt gcats1_main.dats gcats1_sats.c $(OBJECTS_mt)

######

gc0_hats: ; gcc -E -P -D_ATS_MULTITHREAD0 -x c gcats1_master.hats -o gcats1.hats
gc1_hats: ; gcc -E -P -D_ATS_MULTITHREAD1 -x c gcats1_master.hats -o gcats1.hats

######

#
# this kind of whole compilation can probably take advantage of
# interprocedural optimization:
#
gcats1_all_cats.o: gcats1_sats.c $(TARGETS)
	$(ATSCC) $(CCFLAG) -o gcats1_all_cats.o -c -x c gcats1_all.cats

gcats1_mt_all_cats.o: gcats1_sats.c $(TARGETS_mt)
	$(ATSCC) $(CCFLAG) -o gcats1_mt_all_cats.o -c -x c gcats1_all.cats

######

gcats1_sats.c: gcats1.sats
	$(ATSCC) $(ATSCCFLAG) -cc gcats1.sats
gcats1_sats.o: gcats1_sats.c; $(ATSCC) $(CCFLAG) -c gcats1_sats.c

######

gcats1_top_dats.c: gcats1_top.dats
	$(ATSCC) $(ATSCCFLAG) -cc gcats1_top.dats
gcats1_top_dats.o: gcats1_top_dats.c; $(ATSCC) $(CCFLAG) -c gcats1_top_dats.c

gcats1_misc_dats.c: gcats1_misc.dats
	$(ATSCC) $(ATSCCFLAG) -cc gcats1_misc.dats
gcats1_misc_dats.o: gcats1_misc_dats.c
	$(ATSCC) $(CCFLAG) -c gcats1_misc_dats.c

gcats1_freeitmlst_dats.c: gcats1_freeitmlst.dats
	$(ATSCC) $(ATSCCFLAG) -cc gcats1_freeitmlst.dats
gcats1_freeitmlst_dats.o: gcats1_freeitmlst_dats.c
	$(ATSCC) $(CCFLAG) -c gcats1_freeitmlst_dats.c

gcats1_chunk_dats.c: gcats1_chunk.dats
	$(ATSCC) $(ATSCCFLAG) -cc gcats1_chunk.dats
gcats1_chunk_dats.o: gcats1_chunk_dats.c
	$(ATSCC) $(CCFLAG) -c gcats1_chunk_dats.c

gcats1_globalentry_dats.c: gcats1_globalentry.dats
	$(ATSCC) $(ATSCCFLAG) -cc gcats1_globalentry.dats
gcats1_globalentry_dats.o: gcats1_globalentry_dats.c
	$(ATSCC) $(CCFLAG) -c gcats1_globalentry_dats.c

gcats1_multithread_dats.c: gcats1_multithread.dats
	$(ATSCC) $(ATSCCFLAG) -cc gcats1_multithread.dats
gcats1_multithread_dats.o: gcats1_multithread_dats.c
	$(ATSCC) $(CCFLAG) -c gcats1_multithread_dats.c

gcats1_marking_dats.c: gcats1_marking.dats
	$(ATSCC) $(ATSCCFLAG) -cc gcats1_marking.dats
gcats1_marking_dats.o: gcats1_marking_dats.c
	$(ATSCC) $(CCFLAG) -c gcats1_marking_dats.c

gcats1_collecting_dats.c: gcats1_collecting.dats
	$(ATSCC) $(ATSCCFLAG) -cc gcats1_collecting.dats
gcats1_collecting_dats.o: gcats1_collecting_dats.c
	$(ATSCC) $(CCFLAG) -c gcats1_collecting_dats.c

gcats1_autops_dats.c: gcats1_autops.dats
	$(ATSCC) $(ATSCCFLAG) -cc gcats1_autops.dats
gcats1_autops_dats.o: gcats1_autops_dats.c
	$(ATSCC) $(CCFLAG) -c gcats1_autops_dats.c

gcats1_manops_dats.c: gcats1_manops.dats
	$(ATSCC) $(ATSCCFLAG) -cc gcats1_manops.dats
gcats1_manops_dats.o: gcats1_manops_dats.c
	$(ATSCC) $(CCFLAG) -c gcats1_manops_dats.c

######

lines::
	wc -l *.?ats

######

clean::
	rm -f gcats1.hats *_?ats.c *_?ats.o *~

cleanall:: clean; rm -f gc.o gc_mt.o

######
#
# end of [Makefile]
#
######

=== debian/changelog ===
ats-lang-anairiats (0.2.3-1) unstable; urgency=low

  * New upstream release (Closes: #601772)
  * Updated example Makefiles to version 0.2.3

 -- Matthew Danish <mrd@debian.org>  Tue, 14 Dec 2010 15:10:02 -0500

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: devel
 Priority: optional
 Maintainer: Matthew Danish <mrd@debian.org>
-Build-Depends: debhelper (>= 7), libgmp3-dev, libpcre3-dev, libsdl1.2-dev, libgtk2.0-dev, libcairo2-dev
-Standards-Version: 3.8.4
+Build-Depends: debhelper (>= 7), libgmp3-dev, libpcre3-dev, libsdl1.2-dev, libgtk2.0-dev, libcairo2-dev, libsdl-image1.2-dev, libsdl-ttf2.0-dev, libgl1-mesa-dev | libgl-dev, libglu1-mesa-dev | libglu-dev, libblas-dev, liblapack-dev
+Standards-Version: 3.9.1
 Homepage: http://www.ats-lang.org
 
 Package: ats-lang-anairiats

=== debian/rules ===
--- 
+++ 
@@ -27,3 +27,6 @@
 	rm -f ats_env.sh test.sh config.mk
 	rm -f ccomp/lib/output/* ccomp/lib64/output/*
 	rm -f ccomp/lib/*.a ccomp/lib64/*.a
+	rm -f contrib/*/*.o
+	rm -f contrib/clapack/TEST/test
+	rm -f bootstrap1/atsopt bootstrap1/atsopt_gc utils/scripts/atscc utils/scripts/atslib utils/scripts/atspack utils/atslex/atslex
